import pymel.all as pm
from MARS.MarsRigComponent import MarsRigComponent
import MARS.MarsUtilities as mu
reload(mu)

class Gestures(MarsRigComponent):
    def __init__(self,side,limb, controlled_anims, root = None, attrs = [], mins = [], maxs = [], dvs = [], tx = [],tz = [],rx = [], anim = None, orient_to_world = True, node = None,rig = None):
        self.node = node
        
        if node != None: self.node = node
        else:
            try: self.node = self.exist_check('Gestures',anim,'anim')
            except: self.node = None
        
        if self.node == None:
            #Run Function
            MarsRigComponent.__init__(self,'Gestures', side, limb, start = '', end = '')
            
            #Variables
            name = side + '_' + limb
            sdk_joints = []
            ui = None
            i = 1
            
            for i , c_anim in enumerate(controlled_anims):
                attributes = pm.listAttr(c_anim, l = True, st = ['translate*','rotate*'])
                for at in attributes: c_anim.attr(at).unlock()
                new_bone = pm.joint(n=(c_anim + '_' + limb +'_SDK_null'),p=(0,0,0),rad = 0.25)
                new_bone.jointOrient.set(0,0,0)
                sdk_joints.append(new_bone)
                mu.aligner(new_bone,c_anim)
                pm.makeIdentity(new_bone, t = True, r = True, s = True, jo = False, a = True)
                pm.parent(new_bone,c_anim.getParent())
                 
                pm.parent(c_anim,new_bone)
                for at in attributes:
                    c_anim.attr(at).lock()
                    new_bone.attr(at).lock()
                pm.select(cl = True)
                   
            ##Anim##
            if anim == None:
                if attrs:
                    anim = pm.joint(n=(name + '_anim'),p=(0,0,0))
                    mu.default_anim_shape([anim],r=0.75)
                    anim.drawStyle.set(2)
                    if root != None:
                        mu.aligner(anim,root)
                        pm.parentConstraint(root,anim,mo=True)
                    mu.lock_and_hide_attrs(anim,['translate','rotate','scale','v','radius'])
            
                else: anim, ui = self.ui_anim(name + '_gesture',tx = tx,tz = tz,rx = rx)
                mu.con_link(anim,self.node,'anims')
                
                #Component Grp Organization
                component_grp = pm.group(n=(name + '_component_grp'),em=True)
                pm.select(cl = True)
                if attrs or ui != None:
                    anim_grp = pm.group(n=(name + '_anim_grp'),p=component_grp)
                    mu.con_link(anim_grp,self.node,'anim_grp')
                    mu.aligner([anim,component_grp],root)
                    
                #Newer Connections
                mu.con_link(component_grp,self.node,'component_grp')
                if ui != None:
                    pm.parent(ui,anim_grp)
                    if root != None: pm.parentConstraint(root,component_grp,mo = True)
                else: pm.parent(anim,anim_grp)
            else: anim = pm.PyNode(anim)
            
            if attrs:
                for i,at in enumerate(attrs):
                    anim.addAttr(at, at='double', k=True)
                    attribute = anim + '.' + at
                    if mins: pm.addAttr(attribute,e=True,min = mins[i])
                    if maxs: pm.addAttr(attribute,e=True,max = maxs[i])
                    if dvs:
                        pm.addAttr(attribute,e=True,dv = dvs[i])
                        anim.attr(at).set(dvs[i])
                    else:
                        try: v = 0
                        except: v = mins[i]
                        pm.addAttr(attribute,e=True,dv = v)
                        anim.attr(at).set(v)
            pm.select(cl=True)
            
            mu.con_link(anim,self.node,'driver_anim')
            mu.con_link(sdk_joints,self.node,'sdk_joints')
            
            if rig != None: rig.add_to_rig(self)
            
    def ui_anim(self, name,tx = [0,0],tz = [0,0],rx = []):
        #Variables
        nums = [(abs(tx[0] - tx[1]) / 2.00), (abs(tz[0] - tz[1]) / 2.00)] 
        r = max(nums)
        rad = r * 0.25
        hide_attrs = ['ty','scale','rz','ry','visibility','radius']
        if not rx: hide_attrs.append('rx')
        nx, px = [(tx[0] - rad), (tx[1] + rad)]
        nz, pz = [(tz[0] - rad), (tz[1] + rad)]
            
        #Anim and UI
        temp = pm.joint(p = (0,0,0),r = 1)
        anim, null = mu.create_anims(temp, name,suffix = 'anim', separate = True,end = False,use_rad = False,r = rad)
        anim.jointOrientZ.set(90)
            
        #UI Setup
        ui = pm.curve(n = name + '_ui', d = 1,p = [(px,0,pz),(px,0,nz),(nx,0,nz),(nx,0,pz),(px,0,pz)],k = [0,1,2,3,4])
        pm.parent(anim,ui)
        pm.delete(temp,null)
            
        #Attrs Setup
        mu.lock_and_hide_attrs([anim],hide_attrs)
        pm.transformLimits(anim,tx = tx,tz = tz,etx = [1,1],etz = [1,1])
        if rx: pm.transformLimits(anim,tx = tx,tz = tz,etx = [1,1],etz = [1,1])
        mu.con_link(ui,self.node,'ui')
        
        return [anim, ui]
    
    def position_ui(self,translate = None,rotate = None,scale = None):
        pos = translate
        rot = rotate
        sc = scale
        ui = pm.listConnections(self.node.ui)[0]
        if translate != None: ui.translate.set(pos)
        if rotate != None: ui.rotate.set(rot)
        if scale != None: ui.scale.set(sc)
        mu.lock_and_hide_attrs([ui],'all')
    
    def pre_infinity(self):
        for sdk in pm.listConnections(self.node.sdk_joints):
            attrs = pm.listAttr(sdk,w=True,u=True,v=True,k=True)
            nodes = []
            for all in attrs:
                items = pm.listConnections(sdk.attr(all),c = True,d = True)
                for item in items:
                    sdk_node = item[-1]
                    sdk_node.preInfinity.set(3)
    
    def post_infinity(self):
        for sdk in pm.listConnections(self.node.sdk_joints):
            attrs = pm.listAttr(sdk,w=True,u=True,v=True,k=True)
            nodes = []
            for all in attrs:
                items = pm.listConnections(sdk.attr(all),c = True,d = True)
                for item in items:
                    sdk_node = item[-1]
                    sdk_node.postInfinity.set(3)
        
    def linear(self):
        for sdk in pm.listConnections(self.node.sdk_joints):
            attrs = pm.listAttr(sdk,w=True,u=True,v=True,k=True)
            nodes = []
            for all in attrs:
                items = pm.listConnections(sdk.attr(all),c = True,d = True)
                for item in items:
                    sdk_node = item[-1]
                    pm.selectKey(sdk_node,add = True,k=True)
                    pm.keyTangent(itt = 'linear',ott = 'linear',e = True)
            pm.select(cl = True)
    
    def get_ui(self):
        return pm.listConnections(self.node.ui)[0]
    
    def get_sdk_joints(self):
        return pm.listConnections(self.node.sdk_joints)
    
    def hide_joints(self):
        sdk_joints = pm.listConnections(self.node.sdk_joints)
        [x.drawStyle.set(2) for x in sdk_joints]
        
    def show_joints(self):
        sdk_joints = pm.listConnections(self.node.sdk_joints)
        [x.drawStyle.set(0) for x in sdk_joints]
        
    def setup_mirroring(self): pass